# Greenplum related stuff

Greenplum is a PostgreSQL-based database designed for enabling advanced data analysis against terabyte/petabyte size data stores. Multi-domain analysis is enabled thru integration with PostGIS for geospatial processing, GPText (Apache Tika and Apache Solr integration) for advanced text analysis and processing, and an advanced set of machine learning and statistical parallel enabled libraries availabe in Apache MADlib.

## Demos

A collection of demos highlighting various features of the Greenplum database. Most of the demos should work with PostgreSQL also but may require slight modifications (i.e., there is no ```DISTRIBUTED BY ...``` clause in PostgreSQL).


## Windows-Functions

Examples of using Window functions in Greenplum.

## json

A set of Python UDFs for adding document management functionality for JSON objects.

## functions

SQL and stored procedures

## utilities

A set of support or testing utilities.

---
Product Links
- Open Source: https://greenplum.org
- VMware Supported: https://tanzu.vmware.com/greenplum
- Apache MADlib: http://madlib.apache.org/
- Geospatial analytics: https://gpdb.docs.pivotal.io/latest/analytics/postGIS.html
- Text analytics: https://gpdb.docs.pivotal.io/latest/analytics/text.html
